blob: 9dae42b9de6ac365f04a8a419a93864a81b6c053 [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
Amin Hassani13520932017-07-26 11:26:05 -07003#
4# Copyright (C) 2015 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
Jason Kusumabe998f42015-09-03 15:53:13 -070018
19# Script to generate a Brillo update for use by the update engine.
20#
21# usage: brillo_update_payload COMMAND [ARGS]
22# The following commands are supported:
23# generate generate an unsigned payload
24# hash generate a payload or metadata hash
25# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080026# properties generate a properties file from a payload
Amin Hassani13520932017-07-26 11:26:05 -070027# verify verify a payload by recreating a target image.
Jason Kusumabe998f42015-09-03 15:53:13 -070028#
29# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070030# --payload generated unsigned payload output file
31# --source_image if defined, generate a delta payload from the specified
32# image to the target_image
33# --target_image the target image that should be sent to clients
Amin Hassani13520932017-07-26 11:26:05 -070034# --metadata_size_file if defined, generate a file containing the size of the
35# payload metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070036#
37# Hash command arguments:
38# --unsigned_payload the input unsigned payload to generate the hash from
39# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070040# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070041# --payload_hash_file if defined, generate a payload hash and output to the
42# specified file
43# --metadata_hash_file if defined, generate a metadata hash and output to the
44# specified file
45#
46# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070047# --unsigned_payload the input unsigned payload to insert the signatures
48# --payload the output signed payload
49# --signature_size signature sizes in bytes in the following format:
50# "size1:size2[:...]"
51# --payload_signature_file the payload signature files in the following
52# format:
53# "payload_signature1:payload_signature2[:...]"
54# --metadata_signature_file the metadata signature files in the following
55# format:
56# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070057# --metadata_size_file if defined, generate a file containing the size of
58# the signed payload metadata in bytes to the
59# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070060# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080061#
62# Properties command arguments:
63# --payload the input signed or unsigned payload
64# --properties_file the output path where to write the properties, or
65# '-' for stdout.
Amin Hassani13520932017-07-26 11:26:05 -070066# Verify command arguments:
67# --payload payload input file
68# --source_image verify payload to the specified source image.
69# --target_image the target image to verify upon.
Alex Deymo98e691c2016-02-04 21:05:45 -080070
Jason Kusumabe998f42015-09-03 15:53:13 -070071
Alex Deymo61e1fa82016-01-19 15:16:34 -080072# Exit codes:
73EX_UNSUPPORTED_DELTA=100
74
Jason Kusumaf514c542015-11-05 18:43:45 -080075warn() {
76 echo "brillo_update_payload: warning: $*" >&2
77}
78
Gilad Arnold957ce122015-10-14 16:02:55 -070079die() {
80 echo "brillo_update_payload: error: $*" >&2
81 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070082}
83
Gilad Arnold957ce122015-10-14 16:02:55 -070084# Loads shflags. We first look at the default install location; then look for
Amin Hassani2a14d412018-05-31 13:01:09 -070085# crosutils (chroot); finally check our own directory.
Gilad Arnold957ce122015-10-14 16:02:55 -070086load_shflags() {
87 local my_dir="$(dirname "$(readlink -f "$0")")"
88 local path
89 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
90 if [[ -r "${path}/shflags" ]]; then
91 . "${path}/shflags" || die "Could not load ${path}/shflags."
92 return
93 fi
94 done
95 die "Could not find shflags."
96}
97
98load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -070099
Alex Deymoc64ffd52015-09-25 18:10:07 -0700100HELP_GENERATE="generate: Generate an unsigned update payload."
101HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
102for signing."
103HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -0800104HELP_PROPERTIES="properties: Extract payload properties to a file."
Amin Hassani13520932017-07-26 11:26:05 -0700105HELP_VERIFY="verify: Verify a (signed) update payload."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700106
107usage() {
108 echo "Supported commands:"
109 echo
110 echo "${HELP_GENERATE}"
111 echo "${HELP_HASH}"
112 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800113 echo "${HELP_PROPERTIES}"
Amin Hassani13520932017-07-26 11:26:05 -0700114 echo "${HELP_VERIFY}"
Alex Deymoc64ffd52015-09-25 18:10:07 -0700115 echo
116 echo "Use: \"$0 <command> --help\" for more options."
117}
118
119# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700120if [[ $# -lt 1 ]]; then
Alex Deymo98e691c2016-02-04 21:05:45 -0800121 echo "Please specify a command [generate|hash|sign|properties]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700122 exit 1
123fi
124
Alex Deymoc64ffd52015-09-25 18:10:07 -0700125# Parse command.
126COMMAND="${1:-}"
127shift
128
129case "${COMMAND}" in
130 generate)
131 FLAGS_HELP="${HELP_GENERATE}"
132 ;;
133
134 hash)
135 FLAGS_HELP="${HELP_HASH}"
136 ;;
137
138 sign)
139 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700140 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800141
142 properties)
143 FLAGS_HELP="${HELP_PROPERTIES}"
144 ;;
Amin Hassani13520932017-07-26 11:26:05 -0700145
146 verify)
147 FLAGS_HELP="${HELP_VERIFY}"
148 ;;
149
Jason Kusumabe998f42015-09-03 15:53:13 -0700150 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700151 echo "Unrecognized command: \"${COMMAND}\"" >&2
152 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700153 exit 1
154 ;;
155esac
156
Jason Kusumabe998f42015-09-03 15:53:13 -0700157# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700158FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
159${FLAGS_HELP}"
160
161if [[ "${COMMAND}" == "generate" ]]; then
162 DEFINE_string payload "" \
163 "Path to output the generated unsigned payload file."
164 DEFINE_string target_image "" \
165 "Path to the target image that should be sent to clients."
166 DEFINE_string source_image "" \
167 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700168 DEFINE_string metadata_size_file "" \
169 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700170fi
171if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
172 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
173 DEFINE_string signature_size "" \
174 "Signature sizes in bytes in the following format: size1:size2[:...]"
175fi
176if [[ "${COMMAND}" == "hash" ]]; then
177 DEFINE_string metadata_hash_file "" \
178 "Optional: Path to output metadata hash file."
179 DEFINE_string payload_hash_file "" \
180 "Optional: Path to output payload hash file."
181fi
182if [[ "${COMMAND}" == "sign" ]]; then
183 DEFINE_string payload "" \
184 "Path to output the generated unsigned payload file."
185 DEFINE_string metadata_signature_file "" \
186 "The metatada signatures in the following format: \
187metadata_signature1:metadata_signature2[:...]"
188 DEFINE_string payload_signature_file "" \
189 "The payload signatures in the following format: \
190payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700191 DEFINE_string metadata_size_file "" \
192 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700193fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800194if [[ "${COMMAND}" == "properties" ]]; then
195 DEFINE_string payload "" \
196 "Path to the input signed or unsigned payload file."
197 DEFINE_string properties_file "-" \
198 "Path to output the extracted property files. If '-' is passed stdout will \
199be used."
200fi
Amin Hassani13520932017-07-26 11:26:05 -0700201if [[ "${COMMAND}" == "verify" ]]; then
202 DEFINE_string payload "" \
203 "Path to the input payload file."
204 DEFINE_string target_image "" \
205 "Path to the target image to verify upon."
206 DEFINE_string source_image "" \
207 "Optional: Path to a source image. If specified, the delta update is \
208applied to this."
209fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800210
Alex Deymo5fbb1102017-01-12 13:55:52 -0800211DEFINE_string work_dir "${TMPDIR:-/tmp}" "Where to dump temporary files."
Jason Kusumabe998f42015-09-03 15:53:13 -0700212
213# Parse command line flag arguments
214FLAGS "$@" || exit 1
215eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700216set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700217
Alex Deymo5fbb1102017-01-12 13:55:52 -0800218# Override the TMPDIR with the passed work_dir flags, which anyway defaults to
219# ${TMPDIR}.
220TMPDIR="${FLAGS_work_dir}"
221export TMPDIR
222
Alex Deymo89ff9e32015-09-15 19:29:01 -0700223# Associative arrays from partition name to file in the source and target
224# images. The size of the updated area must be the size of the file.
225declare -A SRC_PARTITIONS
226declare -A DST_PARTITIONS
227
Alex Deymo20bdc702016-12-07 21:07:11 -0800228# Associative arrays for the .map files associated with each src/dst partition
229# file in SRC_PARTITIONS and DST_PARTITIONS.
230declare -A SRC_PARTITIONS_MAP
231declare -A DST_PARTITIONS_MAP
232
Sen Jiang788c2d92016-03-09 12:48:40 -0800233# List of partition names in order.
234declare -a PARTITIONS_ORDER
235
Alex Deymo89ff9e32015-09-15 19:29:01 -0700236# A list of temporary files to remove during cleanup.
237CLEANUP_FILES=()
238
Alex Deymo48b502a2015-09-17 19:00:18 -0700239# Global options to force the version of the payload.
240FORCE_MAJOR_VERSION=""
241FORCE_MINOR_VERSION=""
242
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800243# Path to the postinstall config file in target image if exists.
244POSTINSTALL_CONFIG_FILE=""
245
Alex Deymoc97df432015-09-25 17:23:52 -0700246# read_option_int <file.txt> <option_key> [default_value]
247#
248# Reads the unsigned integer value associated with |option_key| in a key=value
249# file |file.txt|. Prints the read value if found and valid, otherwise prints
250# the |default_value|.
251read_option_uint() {
252 local file_txt="$1"
253 local option_key="$2"
254 local default_value="${3:-}"
255 local value
256 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
257 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
258 echo "${value}"
259 return
260 fi
261 fi
262 echo "${default_value}"
263}
264
Sen Jiangd0e9a892016-07-22 16:28:07 -0700265# truncate_file <file_path> <file_size>
266#
267# Truncate the given |file_path| to |file_size| using perl.
268# The truncate binary might not be available.
269truncate_file() {
270 local file_path="$1"
271 local file_size="$2"
272 perl -e "open(FILE, \"+<\", \$ARGV[0]); \
273 truncate(FILE, ${file_size}); \
274 close(FILE);" "${file_path}"
275}
276
Alex Deymo89ff9e32015-09-15 19:29:01 -0700277# Create a temporary file in the work_dir with an optional pattern name.
278# Prints the name of the newly created file.
279create_tempfile() {
280 local pattern="${1:-tempfile.XXXXXX}"
281 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
282}
Jason Kusumabe998f42015-09-03 15:53:13 -0700283
284cleanup() {
285 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700286 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700287
288 # If we are cleaning up after an error, or if we got an error during
289 # cleanup (even if we eventually succeeded) return a non-zero exit
290 # code. This triggers additional logging in most environments that call
291 # this script.
292 if [[ -n "${err}" ]]; then
293 die "Cleanup encountered an error."
294 fi
295}
296
297cleanup_on_error() {
298 trap - INT TERM ERR EXIT
299 cleanup
300 die "Cleanup success after an error."
301}
302
303cleanup_on_exit() {
304 trap - INT TERM ERR EXIT
305 cleanup
306}
307
308trap cleanup_on_error INT TERM ERR
309trap cleanup_on_exit EXIT
310
Alex Deymo48b502a2015-09-17 19:00:18 -0700311
Sen Jiang788c2d92016-03-09 12:48:40 -0800312# extract_image <image> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700313#
314# Detect the format of the |image| file and extract its updatable partitions
315# into new temporary files. Add the list of partition names and its files to the
Sen Jiang788c2d92016-03-09 12:48:40 -0800316# associative array passed in |partitions_array|. If |partitions_order| is
317# passed, set it to list of partition names in order.
Alex Deymo48b502a2015-09-17 19:00:18 -0700318extract_image() {
319 local image="$1"
320
321 # Brillo images are zip files. We detect the 4-byte magic header of the zip
322 # file.
323 local magic=$(head --bytes=4 "${image}" | hexdump -e '1/1 "%.2x"')
324 if [[ "${magic}" == "504b0304" ]]; then
325 echo "Detected .zip file, extracting Brillo image."
326 extract_image_brillo "$@"
327 return
328 fi
329
330 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
331 # bundled here and we will use it to extract the partitions, so the GPT
332 # headers must be valid.
333 if cgpt show -q -n "${image}" >/dev/null; then
334 echo "Detected GPT image, extracting Chrome OS image."
335 extract_image_cros "$@"
336 return
337 fi
338
339 die "Couldn't detect the image format of ${image}"
340}
341
Sen Jiang788c2d92016-03-09 12:48:40 -0800342# extract_image_cros <image.bin> <partitions_array> [partitions_order]
Alex Deymo89ff9e32015-09-15 19:29:01 -0700343#
Alex Deymo48b502a2015-09-17 19:00:18 -0700344# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700345extract_image_cros() {
346 local image="$1"
347 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800348 local partitions_order="${3:-}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700349
350 local kernel root
351 kernel=$(create_tempfile "kernel.bin.XXXXXX")
352 CLEANUP_FILES+=("${kernel}")
353 root=$(create_tempfile "root.bin.XXXXXX")
354 CLEANUP_FILES+=("${root}")
355
356 cros_generate_update_payload --extract \
357 --image "${image}" \
358 --kern_path "${kernel}" --root_path "${root}" \
359 --work_dir "${FLAGS_work_dir}" --outside_chroot
360
Alex Deymo83f2f702015-10-14 14:49:33 -0700361 # Chrome OS uses major_version 1 payloads for all versions, even if the
362 # updater supports a newer major version.
363 FORCE_MAJOR_VERSION="1"
364
Alex Deymo48b502a2015-09-17 19:00:18 -0700365 # When generating legacy Chrome OS images, we need to use "boot" and "system"
366 # for the partition names to be compatible with updating Brillo devices with
367 # Chrome OS images.
368 eval ${partitions_array}[boot]=\""${kernel}"\"
369 eval ${partitions_array}[system]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700370
Sen Jiang788c2d92016-03-09 12:48:40 -0800371 if [[ -n "${partitions_order}" ]]; then
372 eval "${partitions_order}=( \"system\" \"boot\" )"
373 fi
374
Alex Deymo89ff9e32015-09-15 19:29:01 -0700375 local part varname
Alex Deymo48b502a2015-09-17 19:00:18 -0700376 for part in boot system; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700377 varname="${partitions_array}[${part}]"
378 printf "md5sum of %s: " "${varname}"
379 md5sum "${!varname}"
380 done
381}
382
Sen Jiang788c2d92016-03-09 12:48:40 -0800383# extract_image_brillo <target_files.zip> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700384#
385# Extract the A/B updated partitions from a Brillo target_files zip file into
386# new temporary files.
387extract_image_brillo() {
388 local image="$1"
389 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800390 local partitions_order="${3:-}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700391
Alex Deymo48b502a2015-09-17 19:00:18 -0700392 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800393 local ab_partitions_list
394 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
395 CLEANUP_FILES+=("${ab_partitions_list}")
396 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
397 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
398 die "Invalid partition names found in the partition list."
399 fi
Sen Jiang34c711a2017-10-25 17:25:21 -0700400 # Get partition list without duplicates.
401 partitions=($(awk '!seen[$0]++' "${ab_partitions_list}"))
Alex Deymo168b5352015-11-04 13:51:52 -0800402 if [[ ${#partitions[@]} -eq 0 ]]; then
403 die "The list of partitions is empty. Can't generate a payload."
404 fi
405 else
406 warn "No ab_partitions.txt found. Using default."
407 fi
408 echo "List of A/B partitions: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700409
Sen Jiang788c2d92016-03-09 12:48:40 -0800410 if [[ -n "${partitions_order}" ]]; then
411 eval "${partitions_order}=(${partitions[@]})"
412 fi
413
Alex Deymo83f2f702015-10-14 14:49:33 -0700414 # All Brillo updaters support major version 2.
415 FORCE_MAJOR_VERSION="2"
416
Alex Deymo48b502a2015-09-17 19:00:18 -0700417 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800418 # Source image
419 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700420 CLEANUP_FILES+=("${ue_config}")
421 if ! unzip -p "${image}" "META/update_engine_config.txt" \
422 >"${ue_config}"; then
423 warn "No update_engine_config.txt found. Assuming pre-release image, \
424using payload minor version 2"
425 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700426 # For delta payloads, we use the major and minor version supported by the
427 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700428 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
429 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700430 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
431 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800432
433 # Brillo support for deltas started with minor version 3.
434 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
435 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
436Disabling deltas for this source version."
437 exit ${EX_UNSUPPORTED_DELTA}
438 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800439 else
440 # Target image
441 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
442 CLEANUP_FILES+=("${postinstall_config}")
443 if unzip -p "${image}" "META/postinstall_config.txt" \
444 >"${postinstall_config}"; then
445 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
446 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700447 fi
448
449 local part part_file temp_raw filesize
450 for part in "${partitions[@]}"; do
451 part_file=$(create_tempfile "${part}.img.XXXXXX")
452 CLEANUP_FILES+=("${part_file}")
Tao Bao07216d62018-04-11 11:36:38 -0700453
454 # For each partition, we in turn look for its image file under IMAGES/ and
455 # RADIO/ in the given target_files zip file.
456 local path path_in_zip
457 for path in IMAGES RADIO; do
458 if unzip -l "${image}" "${path}/${part}.img" >/dev/null; then
459 path_in_zip="${path}"
460 break
461 fi
462 done
463 [[ -n "${path_in_zip}" ]] || die "Failed to find ${part}.img"
464 unzip -p "${image}" "${path_in_zip}/${part}.img" >"${part_file}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700465
466 # If the partition is stored as an Android sparse image file, we need to
467 # convert them to a raw image for the update.
468 local magic=$(head --bytes=4 "${part_file}" | hexdump -e '1/1 "%.2x"')
469 if [[ "${magic}" == "3aff26ed" ]]; then
470 temp_raw=$(create_tempfile "${part}.raw.XXXXXX")
471 CLEANUP_FILES+=("${temp_raw}")
472 echo "Converting Android sparse image ${part}.img to RAW."
473 simg2img "${part_file}" "${temp_raw}"
474 # At this point, we can drop the contents of the old part_file file, but
475 # we can't delete the file because it will be deleted in cleanup.
476 true >"${part_file}"
477 part_file="${temp_raw}"
478 fi
479
Alex Deymo20bdc702016-12-07 21:07:11 -0800480 # Extract the .map file (if one is available).
481 part_map_file=$(create_tempfile "${part}.map.XXXXXX")
482 CLEANUP_FILES+=("${part_map_file}")
Tao Bao07216d62018-04-11 11:36:38 -0700483 unzip -p "${image}" "${path_in_zip}/${part}.map" >"${part_map_file}" || \
Alex Deymo20bdc702016-12-07 21:07:11 -0800484 part_map_file=""
485
Alex Deymoa479a4d2016-05-11 18:13:49 -0700486 # delta_generator only supports images multiple of 4 KiB. For target images
487 # we pad the data with zeros if needed, but for source images we truncate
488 # down the data since the last block of the old image could be padded on
489 # disk with unknown data.
Alex Deymo48b502a2015-09-17 19:00:18 -0700490 filesize=$(stat -c%s "${part_file}")
491 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
Alex Deymoa479a4d2016-05-11 18:13:49 -0700492 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
493 echo "Rounding DOWN partition ${part}.img to a multiple of 4 KiB."
494 : $(( filesize = filesize & -4096 ))
Alex Deymo04c23052017-04-12 18:15:30 -0700495 if [[ ${filesize} == 0 ]]; then
496 echo "Source partition ${part}.img is empty after rounding down," \
497 "skipping."
498 continue
499 fi
Alex Deymoa479a4d2016-05-11 18:13:49 -0700500 else
501 echo "Rounding UP partition ${part}.img to a multiple of 4 KiB."
502 : $(( filesize = (filesize + 4095) & -4096 ))
503 fi
Sen Jiangd0e9a892016-07-22 16:28:07 -0700504 truncate_file "${part_file}" "${filesize}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700505 fi
506
507 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
Alex Deymo20bdc702016-12-07 21:07:11 -0800508 eval "${partitions_array}_MAP[\"${part}\"]=\"${part_map_file}\""
Alex Deymo48b502a2015-09-17 19:00:18 -0700509 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
510 done
511}
512
Jason Kusumabe998f42015-09-03 15:53:13 -0700513validate_generate() {
514 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700515 die "You must specify an output filename with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700516
517 [[ -n "${FLAGS_target_image}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700518 die "You must specify a target image with --target_image FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700519}
520
521cmd_generate() {
Alex Deymo89ff9e32015-09-15 19:29:01 -0700522 local payload_type="delta"
Jason Kusumabe998f42015-09-03 15:53:13 -0700523 if [[ -z "${FLAGS_source_image}" ]]; then
Alex Deymo89ff9e32015-09-15 19:29:01 -0700524 payload_type="full"
Jason Kusumabe998f42015-09-03 15:53:13 -0700525 fi
526
Alex Deymo48b502a2015-09-17 19:00:18 -0700527 echo "Extracting images for ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700528
Sen Jiang788c2d92016-03-09 12:48:40 -0800529 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
Alex Deymo89ff9e32015-09-15 19:29:01 -0700530 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo48b502a2015-09-17 19:00:18 -0700531 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
Jason Kusumabe998f42015-09-03 15:53:13 -0700532 fi
533
Alex Deymo48b502a2015-09-17 19:00:18 -0700534 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800535 # Common payload args:
536 GENERATOR_ARGS=( -out_file="${FLAGS_payload}" )
537
538 local part old_partitions="" new_partitions="" partition_names=""
Alex Deymo20bdc702016-12-07 21:07:11 -0800539 local old_mapfiles="" new_mapfiles=""
Sen Jiang788c2d92016-03-09 12:48:40 -0800540 for part in "${PARTITIONS_ORDER[@]}"; do
Alex Deymo168b5352015-11-04 13:51:52 -0800541 if [[ -n "${partition_names}" ]]; then
542 partition_names+=":"
543 new_partitions+=":"
544 old_partitions+=":"
Alex Deymo20bdc702016-12-07 21:07:11 -0800545 new_mapfiles+=":"
546 old_mapfiles+=":"
Alex Deymo168b5352015-11-04 13:51:52 -0800547 fi
548 partition_names+="${part}"
549 new_partitions+="${DST_PARTITIONS[${part}]}"
550 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800551 new_mapfiles+="${DST_PARTITIONS_MAP[${part}]:-}"
552 old_mapfiles+="${SRC_PARTITIONS_MAP[${part}]:-}"
Alex Deymo168b5352015-11-04 13:51:52 -0800553 done
554
555 # Target image args:
556 GENERATOR_ARGS+=(
557 -partition_names="${partition_names}"
558 -new_partitions="${new_partitions}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800559 -new_mapfiles="${new_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700560 )
561
Alex Deymo89ff9e32015-09-15 19:29:01 -0700562 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800563 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700564 GENERATOR_ARGS+=(
Alex Deymo168b5352015-11-04 13:51:52 -0800565 -old_partitions="${old_partitions}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800566 -old_mapfiles="${old_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700567 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700568 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
569 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
570 fi
571 fi
572
573 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
574 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700575 fi
576
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700577 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
578 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
579 fi
580
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800581 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
582 GENERATOR_ARGS+=(
583 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
584 )
585 fi
586
Jason Kusumabe998f42015-09-03 15:53:13 -0700587 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700588 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700589
Alex Deymo89ff9e32015-09-15 19:29:01 -0700590 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700591}
592
593validate_hash() {
594 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700595 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700596
597 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700598 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700599--unsigned_payload FILENAME"
600
Jason Kusumabe998f42015-09-03 15:53:13 -0700601 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700602 die "You must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800603
604 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700605 die "You must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700606}
607
608cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700609 "${GENERATOR}" \
610 -in_file="${FLAGS_unsigned_payload}" \
611 -signature_size="${FLAGS_signature_size}" \
612 -out_hash_file="${FLAGS_payload_hash_file}" \
613 -out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700614
Jason Kusumabe998f42015-09-03 15:53:13 -0700615 echo "Done generating hash."
616}
617
618validate_sign() {
619 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700620 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700621
622 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700623 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700624--unsigned_payload FILENAME"
625
626 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700627 die "You must specify the output signed payload with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700628
629 [[ -n "${FLAGS_payload_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700630 die "You must specify the payload signature file with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700631--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700632
633 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700634 die "You must specify the metadata signature file with \
Alex Deymo89ff9e32015-09-15 19:29:01 -0700635--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700636}
637
638cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700639 GENERATOR_ARGS=(
640 -in_file="${FLAGS_unsigned_payload}"
641 -signature_size="${FLAGS_signature_size}"
Amin Hassanib4778292018-05-21 11:48:15 -0700642 -payload_signature_file="${FLAGS_payload_signature_file}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700643 -metadata_signature_file="${FLAGS_metadata_signature_file}"
644 -out_file="${FLAGS_payload}"
645 )
646
647 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
648 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
649 fi
650
651 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700652 echo "Done signing payload."
653}
654
Alex Deymo98e691c2016-02-04 21:05:45 -0800655validate_properties() {
656 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700657 die "You must specify the payload file with --payload FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800658
659 [[ -n "${FLAGS_properties_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700660 die "You must specify a non empty --properties_file FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800661}
662
663cmd_properties() {
664 "${GENERATOR}" \
665 -in_file="${FLAGS_payload}" \
666 -properties_file="${FLAGS_properties_file}"
667}
668
Amin Hassani13520932017-07-26 11:26:05 -0700669validate_verify() {
670 [[ -n "${FLAGS_payload}" ]] ||
671 die "Error: you must specify an input filename with --payload FILENAME"
672
673 [[ -n "${FLAGS_target_image}" ]] ||
674 die "Error: you must specify a target image with --target_image FILENAME"
675}
676
677cmd_verify() {
678 local payload_type="delta"
679 if [[ -z "${FLAGS_source_image}" ]]; then
680 payload_type="full"
681 fi
682
683 echo "Extracting images for ${payload_type} update."
684
685 if [[ "${payload_type}" == "delta" ]]; then
686 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
687 fi
688 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
689
690 declare -A TMP_PARTITIONS
691 for part in "${PARTITIONS_ORDER[@]}"; do
692 local tmp_part=$(create_tempfile "tmp_part.bin.XXXXXX")
693 echo "Creating temporary target partition ${tmp_part} for ${part}"
694 CLEANUP_FILES+=("${tmp_part}")
695 TMP_PARTITIONS[${part}]=${tmp_part}
696 local FILESIZE=$(stat -c%s "${DST_PARTITIONS[${part}]}")
697 echo "Truncating ${TMP_PARTITIONS[${part}]} to ${FILESIZE}"
698 truncate_file "${TMP_PARTITIONS[${part}]}" "${FILESIZE}"
699 done
700
701 echo "Verifying ${payload_type} update."
702 # Common payload args:
703 GENERATOR_ARGS=( -in_file="${FLAGS_payload}" )
704
705 local part old_partitions="" new_partitions="" partition_names=""
706 for part in "${PARTITIONS_ORDER[@]}"; do
707 if [[ -n "${partition_names}" ]]; then
708 partition_names+=":"
709 new_partitions+=":"
710 old_partitions+=":"
711 fi
712 partition_names+="${part}"
713 new_partitions+="${TMP_PARTITIONS[${part}]}"
714 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
715 done
716
717 # Target image args:
718 GENERATOR_ARGS+=(
719 -partition_names="${partition_names}"
720 -new_partitions="${new_partitions}"
721 )
722
723 if [[ "${payload_type}" == "delta" ]]; then
724 # Source image args:
725 GENERATOR_ARGS+=(
726 -old_partitions="${old_partitions}"
727 )
728 fi
729
Amin Hassania566cb62017-08-23 12:36:55 -0700730 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
731 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
732 fi
733
Amin Hassani13520932017-07-26 11:26:05 -0700734 echo "Running delta_generator to verify ${payload_type} payload with args: \
735${GENERATOR_ARGS[@]}"
736 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
737
738 if [[ $? -eq 0 ]]; then
739 echo "Done applying ${payload_type} update."
740 echo "Checking the newly generated partitions against the target partitions"
741 for part in "${PARTITIONS_ORDER[@]}"; do
742 cmp "${TMP_PARTITIONS[${part}]}" "${DST_PARTITIONS[${part}]}"
743 local not_str=""
744 if [[ $? -ne 0 ]]; then
745 not_str="in"
746 fi
747 echo "The new partition (${part}) is ${not_str}valid."
748 done
749 else
750 echo "Failed to apply ${payload_type} update."
751 fi
752}
753
Jason Kusumabe998f42015-09-03 15:53:13 -0700754# Sanity check that the real generator exists:
Sen Jiang13519752016-08-02 16:10:52 -0700755GENERATOR="$(which delta_generator || true)"
Jason Kusumabe998f42015-09-03 15:53:13 -0700756[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
757
758case "$COMMAND" in
759 generate) validate_generate
760 cmd_generate
761 ;;
762 hash) validate_hash
763 cmd_hash
764 ;;
765 sign) validate_sign
766 cmd_sign
767 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800768 properties) validate_properties
769 cmd_properties
770 ;;
Amin Hassani13520932017-07-26 11:26:05 -0700771 verify) validate_verify
772 cmd_verify
773 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700774esac